      SUBROUTINE  ERRMSG( MESSAG, FATAL )
C
c        print out a warning or error message;  abort if error
C
      LOGICAL       FATAL, ONCE
      CHARACTER*(*) MESSAG
      INTEGER       MAXMSG, NUMMSG
      SAVE          MAXMSG, NUMMSG, ONCE
      DATA NUMMSG / 0 /,  MAXMSG / 100 /,  ONCE / .FALSE. /

      IF ( FATAL )  THEN
         WRITE ( *, '(/,2A)' )  ' ******* ERROR >>>>>>  ', MESSAG
         STOP
      END IF

      NUMMSG = NUMMSG + 1
      IF ( NUMMSG.GT.MAXMSG )  THEN
         IF ( .NOT.ONCE )  WRITE ( *,99 )
         ONCE = .TRUE.
      ELSE
         WRITE ( *, '(/,2A)' )  ' ******* WARNING >>>>>>  ', MESSAG
      ENDIF

      RETURN

   99 FORMAT( ///,' >>>>>>  TOO MANY WARNING MESSAGES --  ',
     $   'THEY WILL NO LONGER BE PRINTED  <<<<<<<', /// )
      END
      
      LOGICAL FUNCTION  WRTBAD ( quiet, VARNAM )
C
c          write names of erroneous variables and return 'true'
c
c      input :   VARNAM = name of erroneous variable to be written
c                         ( character, any length )
C ----------------------------------------------------------------------
      CHARACTER*(*)  VARNAM
      INTEGER        MAXMSG, NUMMSG
      LOGICAL quiet
      SAVE  NUMMSG, MAXMSG
      DATA  NUMMSG / 0 /,  MAXMSG / 50 /


      WRTBAD = .TRUE.
      NUMMSG = NUMMSG + 1
      IF ( .NOT. quiet ) 
     $     WRITE ( *, '(3A)' )  ' ****  INPUT VARIABLE  ', VARNAM,
     $     '  IN ERROR  ****'
      IF ( NUMMSG.EQ.MAXMSG  .AND. .NOT. quiet )
     $ CALL  ERRMSG( 'TOO MANY INPUT ERRORS.  ABORTING...$', .TRUE. )
      RETURN
      END
      
      LOGICAL FUNCTION  WRTDIM ( quiet, DIMNAM, MINVAL )
C
c          write name of too-small symbolic dimension and
c          the value it should be increased to;  return 'true'
c
c      input :  DIMNAM = name of symbolic dimension which is too small
c                        ( character, any length )
c               MINVAL = value to which that dimension should be
c                        increased (at least)
C ----------------------------------------------------------------------
      CHARACTER*(*)  DIMNAM
      INTEGER        MINVAL
      LOGICAL quiet


      IF ( .NOT. quiet ) 
     $     WRITE ( *, '(3A,I7)' )  ' ****  SYMBOLIC DIMENSION  ',
     $     DIMNAM, '  SHOULD BE INCREASED TO AT LEAST ', MINVAL
      WRTDIM = .TRUE.
      RETURN
      END

